/***************************************************************************
                          textiosupporter.cpp  -  description
                             -------------------
    begin                : Fri Mar 1 2002
    copyright            : (C) 2002 by Michael Herder
    email                : crapsite@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "textiosupporter.h"

#include <qdir.h>
#include <qfile.h>
#include <qimage.h>
#include <qobject.h>

//will be extended in a following release
//at the moment, it's only used to generate filenames for text output

TextIOSupporter::TextIOSupporter()
{
}
TextIOSupporter::~TextIOSupporter()
{
}
/** No descriptions */
QString TextIOSupporter::getIncreasingFilename(QString filepath,QString format)
{
  QString qs;
  QString new_filepath;
  QString filename;
  QString filetemplate;
  QString ext;
  QFileInfo fi(filepath);
  if(fi.isDir())
    return QString::null;
  filename = fi.fileName();
  ext = "." + fi.extension(false);
  if(ext != ".txt") //valid filename extension ?
  {
    if(format == "TXT")
      ext = ".txt";
    else
      ext = QString::null;
  }
  filename += ext;//add to filename
  filetemplate = filename.left(filename.length()-ext.length());
  //If there's a number on the right side of the filetemplate, get it's
  //value
  QString temp;
  unsigned int cnt;
  bool ok;
  int number = 0;

  for(cnt=0;cnt<filetemplate.length();cnt++)
  {
     temp = filetemplate.right(filetemplate.length()-cnt);
     number = temp.toInt(&ok);
     if(ok)
     {
       //number found
       filetemplate = filetemplate.left(cnt);
       break;
     }
     number = 0;
  }
  int index;
  int pos;
  int value;
  QStringList filelist;

	QDir dir(fi.dir(true));
  dir.setNameFilter(filetemplate+"*");
  filelist = dir.entryList();
  index = 0;
  pos = 0;
  if(filelist.isEmpty() == true)
	{
    QString temp_new_path;
    //new filename
    new_filepath=fi.dir(true).absPath();
    if(new_filepath.right(1) != "/")
      new_filepath+="/";
    new_filepath+=filetemplate;
    temp_new_path = new_filepath;
    temp_new_path+=qs.setNum(number);
    temp_new_path+=ext;
    if(!QFile::exists(temp_new_path))
    {
      //if the file doesn't exist, we don't increase the counter
		  return temp_new_path;
    }
    new_filepath+=qs.setNum(number+1);
    new_filepath+=ext;
		return new_filepath; //we had success
	}
  else
  {
		//there are files that fit the filename template
		//let's try to find the highest index
		for(cnt=0;cnt<filelist.count();cnt++)
    {
			qs = *filelist.at(cnt);
			//remove filename template
			qs = qs.right(qs.length()-filetemplate.length());
      //try to find an extension in the remaining string
			pos = qs.findRev(".");
      if(pos != -1)
			{
				//ext found
				qs = qs.left(pos);
      }
      //check whether what remains is an integer
      ok = 0;
      value = qs.toInt(&ok);
      if(ok)
      {
  		  if(value>number) number = value;
			}
		}
    QString temp_new_path;
    //new filename
    new_filepath=fi.dir(true).absPath();
    if(new_filepath.right(1) != "/")
      new_filepath+="/";
    new_filepath+=filetemplate;
    temp_new_path = new_filepath;
    temp_new_path+=qs.setNum(number);
    temp_new_path+=ext;
    new_filepath+=qs.setNum(number+1);
    new_filepath+=ext;
		return new_filepath; //we had success
  }
  return QString::null;
}
/** No descriptions */
bool TextIOSupporter::isValidFilename(QString filepath)
{
  QFileInfo fi(filepath);
  if(!QFile::exists(filepath))
  {
    QFile f(filepath);
    if(!f.open(IO_WriteOnly))
      return false;
    f.close();
    QFile::remove(filepath);
    return true;
  }
  if(fi.isWritable() && !fi.isDir() && !fi.isSymLink())
    return true;
  return false;
}
